%define soversion 3
%define multilib_arches %{ix86} ia64 %{mips} ppc ppc64 s390 s390x sparcv9 sparc64 x86_64
%define srpmhash() %{lua:
local files = rpm.expand("%_specdir/openssl.spec")
for i, p in ipairs(patches) do
   files = files.." "..p
end
for i, p in ipairs(sources) do
   files = files.." "..p
end
local sha256sum = assert(io.popen("cat "..files.." 2>/dev/null | sha256sum"))
local hash = sha256sum:read("*a")
sha256sum:close()
print(string.sub(hash, 0, 16))
}

%global _performance_build 1

Summary: Utilities from the general purpose cryptography library with TLS implementation
Name: openssl
Version: 3.0.9
Release: 5%{?dist}
License: ASL 2.0
URL: http://www.openssl.org/
Source0: https://www.openssl.org/source/openssl-%{version}.tar.gz
Source1: Makefile.certificate
Source2: genpatches
Source3: make-dummy-cert
Source4: renew-dummy-cert
Source5: configuration-switch.h
Source6: configuration-prefix.h
Source7: 0025-for-tests.patch

Patch3001: 0001-Aarch64-and-ppc64le-use-lib64.patch
Patch3002: 0002-Use-more-general-default-values-in-openssl.cnf.patch
Patch3003: 0003-Do-not-install-html-docs.patch
Patch3004: 0004-Override-default-paths-for-the-CA-directory-tree.patch
Patch3005: 0005-apps-ca-fix-md-option-help-text.patch
Patch3006: 0006-Disable-signature-verification-with-totally-unsafe-h.patch
Patch3007: 0007-Add-support-for-PROFILE-SYSTEM-system-default-cipher.patch
Patch3008: 0008-Add-FIPS_mode-compatibility-macro.patch
Patch3009: 0009-Add-Kernel-FIPS-mode-flag-support.patch
Patch3010: 0010-Add-changes-to-ectest-and-eccurve.patch
Patch3011: 0011-Remove-EC-curves.patch
Patch3012: 0012-Disable-explicit-ec.patch
Patch3013: 0013-skipped-tests-EC-curves.patch
Patch3014: 0024-load-legacy-prov.patch
Patch3015: 0031-tmp-Fix-test-names.patch
Patch3016: 0032-Force-fips.patch
Patch3017: 0033-FIPS-embed-hmac.patch
Patch3018: 0034.fipsinstall_disable.patch
Patch3019: 0035-speed-skip-unavailable-dgst.patch
Patch3020: 0044-FIPS-140-3-keychecks.patch
Patch3021: 0045-FIPS-services-minimize.patch
Patch3022: 0047-FIPS-early-KATS.patch
Patch3023: 0049-Selectively-disallow-SHA1-signatures.patch
Patch3024: 0050-FIPS-enable-pkcs12-mac.patch
Patch3025: 0051-Support-different-R_BITS-lengths-for-KBKDF.patch
Patch3026: 0052-Allow-SHA1-in-seclevel-2-if-rh-allow-sha1-signatures.patch
Patch3027: 0056-strcasecmp.patch
Patch3028: 0058-FIPS-limit-rsa-encrypt.patch
Patch3029: 0060-FIPS-KAT-signature-tests.patch
Patch3030: 0061-Deny-SHA-1-signature-verification-in-FIPS-provider.patch
Patch3031: 0062-fips-Expose-a-FIPS-indicator.patch
Patch3032: 0067-ppc64le-Montgomery-multiply.patch
Patch3033: 0071-AES-GCM-performance-optimization.patch
Patch3034: 0072-ChaCha20-performance-optimizations-for-ppc64le.patch
Patch3035: 0073-FIPS-Use-OAEP-in-KATs-support-fixed-OAEP-seed.patch
Patch3036: 0074-FIPS-Use-digest_sign-digest_verify-in-self-test-eln.patch
Patch3037: 0075-FIPS-Use-FFDHE2048-in-self-test.patch
Patch3038: 0076-FIPS-140-3-DRBG.patch
Patch3039: 0077-FIPS-140-3-zeroization.patch
Patch3040: 0078-Add-FIPS-indicator-parameter-to-HKDF.patch
Patch3041: 0079-Fix-AES-GCM-on-Power-8-CPUs.patch
Patch3042: 0080-rand-Forbid-truncated-hashes-SHA-3-in-FIPS-prov.patch
Patch3043: 0081-signature-Remove-X9.31-padding-from-FIPS-prov.patch
Patch3044: 0083-hmac-Add-explicit-FIPS-indicator-for-key-length.patch
Patch3045: 0084-pbkdf2-Set-minimum-password-length-of-8-bytes.patch
Patch3046: 0085-FIPS-RSA-disable-shake.patch
Patch3047: 0088-signature-Add-indicator-for-PSS-salt-length.patch
Patch3048: 0090-signature-Clamp-PSS-salt-len-to-MD-len.patch
Patch3049: 0091-FIPS-RSA-encapsulate.patch
Patch3050: 0093-FIPS-nodhx.patch
Patch3051: 0100-RSA-PKCS15-implicit-rejection.patch
Patch3052: 0109-fips-Zeroize-out-in-fips-selftest.patch
Patch3053: 0110-GCM-Implement-explicit-FIPS-indicator-for-IV-gen.patch
Patch3054: 0111-fips-Use-salt-16-bytes-in-PBKDF2-selftest.patch

Patch0001: 0780-Do-not-ignore-empty-associated-data-with-AES-SIV-mod.patch
Patch0002: 0804-DH_check-Do-not-try-checking-q-properties-if-it-is-o.patch
Patch0003: Fix-DH_check-excessive-time-with-over-sized-modulus.patch
Patch0004: Add-a-test-for-CVE-2023-3446.patch
Patch0005: process-key-length-and-iv-length-early-if-present.patch
Patch0006: Make-DH-key-safer.patch

Patch5000: enable-sm2_in_ec_support.patch



BuildRequires: gcc g++
BuildRequires: coreutils, perl-interpreter, sed, zlib-devel, /usr/bin/cmp
BuildRequires: lksctp-tools-devel
BuildRequires: /usr/bin/rename /usr/bin/pod2man /usr/sbin/sysctl
BuildRequires: perl(Test::Harness), perl(Test::More), perl(Math::BigInt)
BuildRequires: perl(Module::Load::Conditional), perl(File::Temp)
BuildRequires: perl(Time::HiRes), perl(IPC::Cmd), perl(Pod::Html), perl(Digest::SHA)
BuildRequires: perl(FindBin), perl(lib), perl(File::Compare), perl(File::Copy), perl(bigint)
BuildRequires: git-core systemtap-sdt-devel
Requires: coreutils
Requires: %{name}-libs = %{version}-%{release}

%description
The OpenSSL toolkit provides support for secure communications between
machines. OpenSSL includes a certificate management tool and shared
libraries which provide various cryptographic algorithms and
protocols.

%package libs
Summary: A general purpose cryptography library with TLS implementation
Requires: ca-certificates >= 2008-5
Requires: crypto-policies >= 20180730
Recommends: openssl-pkcs11

%description libs
OpenSSL is a toolkit for supporting cryptography. The openssl-libs
package contains the libraries that are used by various applications which
support cryptographic algorithms and protocols.

%package devel
Summary: Files for development of applications which will use OpenSSL
Requires: %{name}-libs = %{version}-%{release}
Requires: pkgconfig

%description devel
OpenSSL is a toolkit for supporting cryptography. The openssl-devel
package contains include files needed to develop applications which
support various cryptographic algorithms and protocols.

%package perl
Summary: Perl scripts provided with OpenSSL
Requires: perl-interpreter
Requires: %{name} = %{version}-%{release}

%description perl
OpenSSL is a toolkit for supporting cryptography. The openssl-perl
package provides Perl scripts for converting certificates and keys
from other formats to the formats used by the OpenSSL toolkit.

%prep
%autosetup -S git -n %{name}-%{version}

%build
sslarch=%{_os}-%{_target_cpu}
%ifarch %ix86
sslarch=linux-elf
if ! echo %{_target} | grep -q i686 ; then
	sslflags="no-asm 386"
fi
%endif
%ifarch x86_64
sslflags=enable-ec_nistp_64_gcc_128
%endif
%ifarch sparcv9
sslarch=linux-sparcv9
sslflags=no-asm
%endif
%ifarch sparc64
sslarch=linux64-sparcv9
sslflags=no-asm
%endif
%ifarch alpha alphaev56 alphaev6 alphaev67
sslarch=linux-alpha-gcc
%endif
%ifarch s390 sh3eb sh4eb
sslarch="linux-generic32 -DB_ENDIAN"
%endif
%ifarch s390x
sslarch="linux64-s390x"
%endif
%ifarch %{arm}
sslarch=linux-armv4
%endif
%ifarch aarch64
sslarch=linux-aarch64
sslflags=enable-ec_nistp_64_gcc_128
%endif
%ifarch sh3 sh4
sslarch=linux-generic32
%endif
%ifarch ppc64 ppc64p7
sslarch=linux-ppc64
%endif
%ifarch ppc64le
sslarch="linux-ppc64le"
sslflags=enable-ec_nistp_64_gcc_128
%endif
%ifarch mips mipsel
sslarch="linux-mips32 -mips32r2"
%endif
%ifarch mips64 mips64el
sslarch="linux64-mips64 -mips64r2"
%endif
%ifarch mips64el
sslflags=enable-ec_nistp_64_gcc_128
%endif
%ifarch riscv64
sslarch=linux-generic64
%endif
ktlsopt=enable-ktls
%ifarch armv7hl
ktlsopt=disable-ktls
%endif


RPM_OPT_FLAGS="$RPM_OPT_FLAGS -Wa,--noexecstack -Wa,--generate-missing-build-notes=yes -DPURIFY $RPM_LD_FLAGS"

export HASHBANGPERL=/usr/bin/perl

%define fips %{version}-%{srpmhash}

./Configure \
	--prefix=%{_prefix} --openssldir=%{_sysconfdir}/pki/tls ${sslflags} \
	--system-ciphers-file=%{_sysconfdir}/crypto-policies/back-ends/openssl.config \
	zlib enable-camellia enable-seed enable-rfc3779 enable-sctp \
	enable-cms enable-md2 enable-rc5 ${ktlsopt} enable-fips\
	no-mdc2 enable-sm2 enable-sm3 enable-sm4 no-ec2m enable-buildtest-c++\
	shared  ${sslarch} $RPM_OPT_FLAGS '-DDEVRANDOM="\"/dev/urandom\"" -DREDHAT_FIPS_VERSION="\"%{fips}\""'\
	-Wl,--allow-multiple-definition

%make_build all
for i in libcrypto.pc libssl.pc openssl.pc ; do
  sed -i '/^Libs.private:/{s/-L[^ ]* //;s/-Wl[^ ]* //}' $i
done

%check
(sysctl net.sctp.addip_enable=1 && sysctl net.sctp.auth_enable=1) || \
(echo 'Failed to enable SCTP AUTH chunks, disabling SCTP for tests...' &&
 sed '/"msan" => "default",/a\ \ "sctp" => "default",' configdata.pm > configdata.pm.new && \
 touch -r configdata.pm configdata.pm.new && \
 mv -f configdata.pm.new configdata.pm)

patch -p1 -R < %{PATCH3004}
patch -p1 < %{SOURCE7}

OPENSSL_ENABLE_MD5_VERIFY=
export OPENSSL_ENABLE_MD5_VERIFY

OPENSSL_ENABLE_SHA1_SIGNATURES=
export OPENSSL_ENABLE_SHA1_SIGNATURES

OPENSSL_SYSTEM_CIPHERS_OVERRIDE=xyz_nonexistent_file
export OPENSSL_SYSTEM_CIPHERS_OVERRIDE
LD_LIBRARY_PATH=. apps/openssl dgst -binary -sha256 -mac HMAC -macopt hexkey:f4556650ac31d35461610bac4ed81b1a181b2d8a43ea2854cbae22ca74560813 < providers/fips.so > providers/fips.so.hmac
objcopy --update-section .rodata1=providers/fips.so.hmac providers/fips.so providers/fips.so.mac
mv providers/fips.so.mac providers/fips.so

make test HARNESS_JOBS=8

%define __spec_install_post \
    %{?__debug_package:%{__debug_install_post}} \
    %{__arch_install_post} \
    %{__os_install_post} \
    LD_LIBRARY_PATH=. apps/openssl dgst -binary -sha256 -mac HMAC -macopt hexkey:f4556650ac31d35461610bac4ed81b1a181b2d8a43ea2854cbae22ca74560813 < %{buildroot}%{_libdir}/ossl-modules/fips.so > %{buildroot}%{_libdir}/ossl-modules/fips.so.hmac \
    objcopy --update-section .rodata1=%{buildroot}%{_libdir}/ossl-modules/fips.so.hmac %{buildroot}%{_libdir}/ossl-modules/fips.so %{buildroot}%{_libdir}/ossl-modules/fips.so.mac \
    mv %{buildroot}%{_libdir}/ossl-modules/fips.so.mac %{buildroot}%{_libdir}/ossl-modules/fips.so \
    rm %{buildroot}%{_libdir}/ossl-modules/fips.so.hmac \
%{nil}

%define __provides_exclude_from %{_libdir}/openssl

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
install -d %{buildroot}{%{_bindir},%{_includedir},%{_libdir},%{_mandir},%{_libdir}/openssl,%{_pkgdocdir}}
%make_install
rename so.%{soversion} so.%{version} %{buildroot}%{_libdir}/*.so.%{soversion}
for lib in %{buildroot}%{_libdir}/*.so.%{version} ; do
	chmod 755 ${lib}
	ln -s -f `basename ${lib}` %{buildroot}%{_libdir}/`basename ${lib} .%{version}`
	ln -s -f `basename ${lib}` %{buildroot}%{_libdir}/`basename ${lib} .%{version}`.%{soversion}
done

for lib in %{buildroot}%{_libdir}/*.a ; do
	rm -f ${lib}
done

mkdir -p %{buildroot}%{_sysconfdir}/pki/tls/certs
install -m644 %{SOURCE1} %{buildroot}%{_pkgdocdir}/Makefile.certificate
install -m755 %{SOURCE3} %{buildroot}%{_bindir}/make-dummy-cert
install -m755 %{SOURCE4} %{buildroot}%{_bindir}/renew-dummy-cert

mv %{buildroot}%{_sysconfdir}/pki/tls/misc/*.pl %{buildroot}%{_bindir}
mv %{buildroot}%{_sysconfdir}/pki/tls/misc/tsget %{buildroot}%{_bindir}


pushd %{buildroot}%{_mandir}
mv man5/config.5ossl man5/openssl.cnf.5
popd

mkdir -m755 %{buildroot}%{_sysconfdir}/pki/CA
mkdir -m700 %{buildroot}%{_sysconfdir}/pki/CA/private
mkdir -m755 %{buildroot}%{_sysconfdir}/pki/CA/certs
mkdir -m755 %{buildroot}%{_sysconfdir}/pki/CA/crl
mkdir -m755 %{buildroot}%{_sysconfdir}/pki/CA/newcerts


touch -r %{SOURCE1} %{buildroot}%{_sysconfdir}/pki/tls/openssl.cnf
touch -r %{SOURCE1} %{buildroot}%{_sysconfdir}/pki/tls/ct_log_list.cnf

rm -f %{buildroot}%{_sysconfdir}/pki/tls/openssl.cnf.dist
rm -f %{buildroot}%{_sysconfdir}/pki/tls/ct_log_list.cnf.dist
rm -f %{buildroot}%{_sysconfdir}/pki/tls/fipsmodule.cnf


basearch=%{_arch}
%ifarch %{ix86}
basearch=i386
%endif
%ifarch sparcv9
basearch=sparc
%endif
%ifarch sparc64
basearch=sparc64
%endif


sed -i '/^\#ifndef OPENSSL_NO_SSL_TRACE/i\
#ifndef OPENSSL_NO_SSL3\
# define OPENSSL_NO_SSL3\
#endif' %{buildroot}/%{_prefix}/include/openssl/opensslconf.h

%ifarch %{multilib_arches}
install -m644 %{SOURCE6} \
	%{buildroot}/%{_prefix}/include/openssl/configuration-${basearch}.h
cat %{buildroot}/%{_prefix}/include/openssl/configuration.h >> \
	%{buildroot}/%{_prefix}/include/openssl/configuration-${basearch}.h
install -m644 %{SOURCE5} \
	%{buildroot}/%{_prefix}/include/openssl/configuration.h
%endif

%files
%license LICENSE.txt
%doc NEWS.md README.md
%{_bindir}/make-dummy-cert
%{_bindir}/renew-dummy-cert
%{_bindir}/openssl
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*
%{_pkgdocdir}/Makefile.certificate
%exclude %{_mandir}/man1/*.pl*
%exclude %{_mandir}/man1/tsget*

%files libs
%license LICENSE.txt
%dir %{_sysconfdir}/pki/tls
%dir %{_sysconfdir}/pki/tls/certs
%dir %{_sysconfdir}/pki/tls/misc
%dir %{_sysconfdir}/pki/tls/private
%config(noreplace) %{_sysconfdir}/pki/tls/openssl.cnf
%config(noreplace) %{_sysconfdir}/pki/tls/ct_log_list.cnf
%attr(0755,root,root) %{_libdir}/libcrypto.so.%{version}
%{_libdir}/libcrypto.so.%{soversion}
%attr(0755,root,root) %{_libdir}/libssl.so.%{version}
%{_libdir}/libssl.so.%{soversion}
%attr(0755,root,root) %{_libdir}/engines-%{soversion}
%attr(0755,root,root) %{_libdir}/ossl-modules

%files devel
%doc CHANGES.md doc/dir-locals.example.el doc/openssl-c-indent.el
%{_prefix}/include/openssl
%{_libdir}/*.so
%{_mandir}/man3/*
%{_libdir}/pkgconfig/*.pc

%files perl
%{_bindir}/c_rehash
%{_bindir}/*.pl
%{_bindir}/tsget
%{_mandir}/man1/*.pl*
%{_mandir}/man1/tsget*
%dir %{_sysconfdir}/pki/CA
%dir %{_sysconfdir}/pki/CA/private
%dir %{_sysconfdir}/pki/CA/certs
%dir %{_sysconfdir}/pki/CA/crl
%dir %{_sysconfdir}/pki/CA/newcerts


%changelog
* Thu Nov 23 2023 Feng Weiyao <wynnfeng@tencent.com> - 3.0.9-5
- Resolves: CVE-2023-5678, CVE-2023-5363

* Mon Oct 23 2023 Feng Weiyao <wynnfeng@tencent.com> - 3.0.9-4
- Resolves: CVE-2023-3446

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.9-3
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 29 2023 Feng Weiyao <wynnfeng@tencent.com> - 3.0.9-2
- Resolves: CVE-2023-2975
  Resolves: CVE-2023-3817

* Tue Aug 1 2023 Feng Weiyao <wynnfeng@tencent.com> - 3.0.9-1
- update to version 3.0.9
  Resolves: CVE-2023-0464            
  Resolves: CVE-2023-0465            
  Resolves: CVE-2023-0466            
  Resolves: CVE-2023-1255            
  Resolves: CVE-2023-2650

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.8-4
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 4 2023 Feng Weiyao <wynnfeng@tencent.com> - 3.0.8-3
- add fips patches

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.8-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Feb 24 2023 Feng Weiyao <wynnfeng@tencent.com> - 3.0.8-1
- update to 3.0.8
- support SM2, SM3 and SM4

* Fri Dec 2 2022 Anakin Zhang <anakinzhang@tencent.com> - 3.0.5-2
- Fixed CVE-2022-3786
- Fixed CVE-2022-3602

* Tue Aug 2 2022 Anakin Zhang <anakinzhang@tencent.com> - 3.0.5-1
- Initial build